package com.jcg.objectmethods;

public class CloneableStudent implements Cloneable {

    private int studentId;
    private String studentName;
    private CloneableCourse enrolledCourse;

    public CloneableStudent(int id, String name, CloneableCourse course){
        this.studentId = id;
        this.studentName = name;
        this.enrolledCourse = course;
    }
    
    @Override
    protected Object clone() throws CloneNotSupportedException 
    {
        CloneableStudent deepClone = (CloneableStudent)super.clone();
        deepClone.enrolledCourse = (CloneableCourse)this.enrolledCourse.clone();
        return deepClone;
    }

    public String getStudentName() {
        return studentName;
    }

    public Course getEnrolledCourse() {
        return enrolledCourse;
    }
    
    
}
